<template>
    <div class="signup pa-16">
        <v-row>
            <v-col md="4" offset-md="4">
                <v-row>
                    <v-col class="pt-0 text-left">
                        <v-stepper
                            v-model="currentStep"
                            class="transparent-bg elevation-0"
                        >
                            <v-row>
                                <v-col class="pb-0"
                                    ><p class="highlight-text mb-0">
                                        {{ $t('signUp.step') }}
                                        {{ currentStep }}
                                        {{ $t('signUp.stepOf') }}
                                        {{ totalSteps }}
                                    </p>
                                </v-col>
                            </v-row>

                            <v-stepper-items>
                                <!-- STEP 1 -->
                                <v-stepper-content step="1" class="pa-0">
                                    <v-row
                                        ><v-col class="pt-0"
                                            ><h3>
                                                {{ $t('common.choosePlan') }}
                                            </h3></v-col
                                        ></v-row
                                    >
                                    <v-row>
                                        <v-col>
                                            <v-tabs
                                                v-model="tab"
                                                color="badge"
                                                background-color="transparent"
                                            >
                                                <v-tab
                                                    v-for="(plan, p) in plans"
                                                    :key="'plan-' + p"
                                                    class="pl-0 pr-16 text-left lowercase font-syne-bold"
                                                    @click="selectPlan(p)"
                                                    >{{ plan.name }}<br />{{
                                                        plan.price
                                                    }}</v-tab
                                                >
                                            </v-tabs>
                                            <v-tabs-items
                                                v-model="tab"
                                                class="transparent-bg"
                                            >
                                                <v-tab-item
                                                    v-for="(plan, p) in plans"
                                                    :key="'plan-item-' + p"
                                                >
                                                    <ul class="pt-5">
                                                        <li
                                                            v-for="(feature,
                                                            pf) in plan.features"
                                                            :key="
                                                                'plan-feature-' +
                                                                pf
                                                            "
                                                        >
                                                            <v-icon
                                                                small
                                                                class="mr-1"
                                                                color="white"
                                                            >
                                                                mdi-check </v-icon
                                                            >{{ feature }}
                                                        </li>
                                                    </ul>
                                                </v-tab-item>
                                            </v-tabs-items>
                                            <v-btn
                                                class="mt-5 lowercase br-0 pl-10 pr-10 font-syne-bold"
                                                color="badge"
                                                @click="currentStep = 2"
                                                >{{
                                                    $t('buttons.nextBtn')
                                                }}</v-btn
                                            >
                                        </v-col>
                                    </v-row>
                                </v-stepper-content>

                                <!-- STEP 2 -->
                                <v-stepper-content step="2" class="pa-0">
                                    <v-row
                                        ><v-col class="pt-0"
                                            ><h3>
                                                {{ $t('common.createAccount') }}
                                            </h3></v-col
                                        ></v-row
                                    >
                                    <v-form
                                        ref="registrationForm"
                                        lazy-validation
                                        @submit.prevent
                                    >
                                        <v-row>
                                            <v-col>
                                                <v-col
                                                    cols="12"
                                                    class="form-field font-metropolis-regular pl-0"
                                                >
                                                    <!-- NAME -->
                                                    <v-text-field
                                                        ref="name"
                                                        v-model="
                                                            form.name.value
                                                        "
                                                        :label="
                                                            $t('form.name.text')
                                                        "
                                                        :placeholder="
                                                            $t(
                                                                'form.name.placeholder'
                                                            )
                                                        "
                                                        solo
                                                        required
                                                        :rules="[requiredRules]"
                                                    ></v-text-field>

                                                    <!-- EMAIL -->
                                                    <v-text-field
                                                        ref="email"
                                                        v-model="
                                                            form.email.value
                                                        "
                                                        :label="
                                                            $t(
                                                                'form.email.text'
                                                            )
                                                        "
                                                        :placeholder="
                                                            $t(
                                                                'form.email.placeholder'
                                                            )
                                                        "
                                                        solo
                                                        :rules="[
                                                            requiredRules,
                                                            requiredEmail,
                                                        ]"
                                                        :error-messages="
                                                            form.email.error
                                                        "
                                                    ></v-text-field>

                                                    <!-- PASSWORD -->
                                                    <v-text-field
                                                        ref="password"
                                                        v-model="
                                                            form.password.value
                                                        "
                                                        :append-icon="
                                                            showPass
                                                                ? 'mdi-eye'
                                                                : 'mdi-eye-off'
                                                        "
                                                        :rules="[
                                                            requiredRules,
                                                            requiredMin,
                                                        ]"
                                                        :type="
                                                            showPass
                                                                ? 'text'
                                                                : 'password'
                                                        "
                                                        name="input-10-2"
                                                        :label="
                                                            $t(
                                                                'form.password.text'
                                                            )
                                                        "
                                                        :placeholder="
                                                            $t(
                                                                'form.password.placeholder'
                                                            )
                                                        "
                                                        :hint="
                                                            $t(
                                                                'form.password.min'
                                                            )
                                                        "
                                                        class="input-group--focused"
                                                        solo
                                                        @click:append="
                                                            showPass = !showPass
                                                        "
                                                    ></v-text-field>

                                                    <v-checkbox
                                                        ref="terms"
                                                        v-model="checkbox"
                                                        color="grey"
                                                        background-color="transparent"
                                                        :rules="[requiredRules]"
                                                        required
                                                        class="mb-0"
                                                        off-icon="mdi-checkbox-blank-circle-outline"
                                                        on-icon="mdi-checkbox-marked-circle-outline"
                                                    >
                                                        <template v-slot:label>
                                                            <div
                                                                class="font12 highlight-white-text"
                                                                @click.stop=""
                                                            >
                                                                {{
                                                                    $t(
                                                                        'signUp.agreeTerms'
                                                                    )
                                                                }}
                                                            </div>
                                                        </template>
                                                    </v-checkbox>
                                                </v-col>
                                                <v-btn
                                                    class="mt-5 lowercase br-0 pl-10 pr-10 font-syne-bold"
                                                    color="badge"
                                                    @click="validate"
                                                    >{{
                                                        $t('buttons.nextBtn')
                                                    }}</v-btn
                                                >
                                            </v-col>
                                        </v-row>
                                    </v-form>
                                </v-stepper-content>

                                <!-- STEP 3 -->
                                <v-stepper-content step="3" class="pa-0">
                                    <v-row
                                        ><v-col class="pt-0"
                                            ><h3>
                                                {{ $t('common.setupPayment') }}
                                            </h3></v-col
                                        ></v-row
                                    >
                                    <v-form
                                        ref="registrationPaymentForm"
                                        lazy-validation
                                        @submit.prevent
                                    >
                                        <v-row>
                                            <v-col>
                                                <v-row>
                                                    <v-col
                                                        md="6"
                                                        cols="12"
                                                        class="form-field font-metropolis-regular"
                                                    >
                                                        <!-- FIRST NAME -->
                                                        <v-text-field
                                                            ref="firstName"
                                                            v-model="
                                                                form2.firstName
                                                                    .value
                                                            "
                                                            :label="
                                                                $t(
                                                                    'form.firstName.text'
                                                                )
                                                            "
                                                            :placeholder="
                                                                $t(
                                                                    'form.firstName.placeholder'
                                                                )
                                                            "
                                                            solo
                                                            :rules="[
                                                                requiredRules,
                                                            ]"
                                                        ></v-text-field>
                                                    </v-col>
                                                    <v-col md="6" cols="12">
                                                        <!-- LAST NAME -->
                                                        <v-text-field
                                                            ref="lastName"
                                                            v-model="
                                                                form2.lastName
                                                                    .value
                                                            "
                                                            :label="
                                                                $t(
                                                                    'form.lastName.text'
                                                                )
                                                            "
                                                            :placeholder="
                                                                $t(
                                                                    'form.lastName.placeholder'
                                                                )
                                                            "
                                                            solo
                                                            :rules="[
                                                                requiredRules,
                                                            ]"
                                                        ></v-text-field>
                                                    </v-col>
                                                    <v-col cols="12">
                                                        <!-- CREDIT CARD NUMBER -->
                                                        <v-text-field
                                                            ref="cc"
                                                            v-model="
                                                                form2.cc.value
                                                            "
                                                            v-mask="
                                                                '#### #### #### ####'
                                                            "
                                                            :rules="[
                                                                requiredRules,
                                                            ]"
                                                            name="input-10-2"
                                                            :label="
                                                                $t(
                                                                    'form.cc.text'
                                                                )
                                                            "
                                                            :placeholder="
                                                                $t(
                                                                    'form.cc.placeholder'
                                                                )
                                                            "
                                                            class="input-group--focused"
                                                            solo
                                                            @click:append="
                                                                showPass = !showPass
                                                            "
                                                            ><template
                                                                slot="append"
                                                            >
                                                                <img
                                                                    :src="visa"
                                                                    width="51"
                                                                    height="17"
                                                                    class="mr-2"
                                                                />
                                                                <img
                                                                    :src="
                                                                        master
                                                                    "
                                                                    width="35"
                                                                    height="19"
                                                                /> </template
                                                        ></v-text-field>
                                                    </v-col>
                                                    <v-col
                                                        md="6"
                                                        cols="12"
                                                        class="form-field font-metropolis-regular"
                                                    >
                                                        <!-- EXPIRY DATE -->
                                                        <v-text-field
                                                            ref="expiryDate"
                                                            v-model="
                                                                form2.expiryDate
                                                                    .value
                                                            "
                                                            v-mask="'##/##'"
                                                            :label="
                                                                $t(
                                                                    'form.expiryDate.text'
                                                                )
                                                            "
                                                            :placeholder="
                                                                $t(
                                                                    'form.expiryDate.placeholder'
                                                                )
                                                            "
                                                            solo
                                                            :rules="[
                                                                requiredRules,
                                                            ]"
                                                        ></v-text-field>
                                                    </v-col>
                                                    <v-col md="6" cols="12">
                                                        <!-- CVV -->
                                                        <v-tooltip
                                                            v-model="showCVV"
                                                            top
                                                        >
                                                            <template
                                                                v-slot:activator="{
                                                                    on,
                                                                }"
                                                            >
                                                                <v-text-field
                                                                    ref="cvv"
                                                                    v-model="
                                                                        form2
                                                                            .cvv
                                                                            .value
                                                                    "
                                                                    v-mask="
                                                                        '###'
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.cvv.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.cvv.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                    :rules="[
                                                                        requiredRules,
                                                                        requiredCVV,
                                                                    ]"
                                                                    append-icon="mdi-information-outline"
                                                                    @click:append="
                                                                        showCVV = !showCVV
                                                                    "
                                                                ></v-text-field>
                                                            </template>
                                                            <span
                                                                >{{
                                                                    $t(
                                                                        'form.cvv.hint'
                                                                    )
                                                                }}
                                                            </span>
                                                        </v-tooltip>
                                                    </v-col>
                                                </v-row>
                                                <v-row>
                                                    <v-col cols="12">
                                                        <p
                                                            class="highlight-white-text mb-0"
                                                        >
                                                            {{
                                                                $t(
                                                                    'common.yourSubscription'
                                                                )
                                                            }}
                                                        </p>
                                                        <p
                                                            class="highlight-white-text"
                                                        >
                                                            {{
                                                                plans[
                                                                    selectedPlan
                                                                ].name
                                                            }}
                                                            <v-btn
                                                                small
                                                                text
                                                                color="badge"
                                                                class="lowercase"
                                                                @click="
                                                                    currentStep = 1
                                                                "
                                                                >{{
                                                                    $t(
                                                                        'buttons.changeBtn'
                                                                    )
                                                                }}</v-btn
                                                            >
                                                        </p>
                                                    </v-col>
                                                    <v-col>
                                                        <v-btn
                                                            class="lowercase br-0 pl-10 pr-10 font-syne-bold"
                                                            color="badge"
                                                            @click="submit"
                                                            >{{
                                                                $t(
                                                                    'buttons.payNowBtn'
                                                                )
                                                            }}</v-btn
                                                        >
                                                    </v-col>
                                                </v-row>
                                            </v-col>
                                        </v-row>
                                    </v-form>
                                </v-stepper-content>
                            </v-stepper-items>
                        </v-stepper>
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
const { VueMaskDirective } = require('v-mask')

Vue.directive('mask', VueMaskDirective)

@Component({
    computed: mapGetters({}),
    middleware: ['authenticated'],
})
export default class SignUp extends Vue {
    // Data
    currentStep: Number = 1
    totalSteps: Number = 3
    selectedPlan: Number = 0 // default plan
    tab: any = null
    showPass: Boolean = false
    showCVV: Boolean = false
    checkbox: Boolean = false
    formHasErrors: Boolean = false
    form: { [key: string]: any } = {
        name: {
            value: '',
            error: null,
            requestKey: 'name',
        },
        email: {
            value: '',
            error: null,
            requestKey: 'email',
        },
        password: {
            value: '',
            error: null,
            requestKey: 'password',
        },
    }

    form2: { [key: string]: any } = {
        firstName: {
            value: '',
            error: null,
            requestKey: 'first_name',
        },
        lastName: {
            value: '',
            error: null,
            requestKey: 'last_name',
        },
        cc: {
            value: '',
            error: null,
            requestKey: 'cc',
        },
        expiryDate: {
            value: '',
            error: null,
            requestKey: 'expiry_date',
        },
        cvv: {
            value: '',
            error: null,
            requestKey: 'cvv',
        },
    }

    plans: any = [
        {
            name: 'Hype2u Basic',
            price: 'RM299/month',
            features: [
                this.$t('home.plan1Feature1'),
                this.$t('home.plan1Feature2'),
                this.$t('home.plan1Feature3'),
                this.$t('home.plan1Feature4'),
                this.$t('home.plan1Feature5'),
                this.$t('home.plan1Feature6'),
            ],
        },
        {
            name: 'Hype2u Unlimited',
            price: 'RM499/month',
            features: [
                this.$t('home.plan2Feature1'),
                this.$t('home.plan2Feature2'),
                this.$t('home.plan2Feature3'),
                this.$t('home.plan2Feature4'),
                this.$t('home.plan2Feature5'),
                this.$t('home.plan2Feature6'),
            ],
        },
    ]

    visa: String = require('~/assets/images/visa.png')
    master: String = require('~/assets/images/mastercard.png')
    isButtonDisabled = false

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    requiredEmail(v: string) {
        if (v) {
            if (v.length > 0) {
                const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
                return (
                    pattern.test(v) || this.$t('form.validation.invalidEmail')
                )
            }
        }
        return this.$t('form.validation.required')
    }

    requiredMin(v: string) {
        if (v) {
            if (v.length >= 8) {
                return true
            }
        }
        return this.$t('form.password.min')
    }

    requiredCVV(v: string) {
        if (v) {
            if (v.length === 3) {
                return true
            }
        }
        return this.$t('form.cvv.max')
    }

    // Methods
    selectPlan(p: Number) {
        this.selectedPlan = p
    }

    validate() {
        this.formHasErrors = false

        // validate step 2 form
        if (
            !(this.$refs.registrationForm as Vue & {
                validate: () => boolean
            }).validate()
        ) {
            this.formHasErrors = true
        }

        if (!this.formHasErrors) {
            // go to step 3
            if (this.currentStep === 2) {
                this.currentStep = 3
            }
        }
    }

    submit() {
        // validate step 3 form
        if (this.currentStep === 3) {
            if (
                !(this.$refs.registrationPaymentForm as Vue & {
                    validate: () => boolean
                }).validate()
            ) {
                this.formHasErrors = true
            } else {
                this.isButtonDisabled = true

                this.$api.auth
                    .register(this.form, this.form2, this.$cookies.get('gc'))
                    .then((response) => {
                        this.isButtonDisabled = false

                        // Save data to cookie and vuex
                        this.$cookies.set('t', response.data.token)
                        this.$axios.setToken(response.data.token, 'Bearer')

                        // Remove guest session cookie
                        this.$cookies.remove('gc')

                        // Display snackbar
                        const val = {
                            text: this.$t('snackbar.registerSuccess'),
                            color: 'green',
                            icon: 'mdi-check',
                        }
                        this.$store.dispatch('snackbar/displaySnackBar', val)

                        // Redirect
                        this.$router.push('/')
                    })
                    .catch((error) => {
                        if (error.response.status === 401) {
                            return
                        }

                        // Get errors object
                        const errors = error.response.data.errors

                        // Get keys of error
                        const errorKeys: string[] = Object.keys(errors)

                        // Set error messages
                        for (const errorKey of errorKeys) {
                            // Display snackbar
                            const val = {
                                text: errors[errorKey][0],
                                color: 'red',
                                icon: ' mdi-close-circle',
                            }
                            this.$store.dispatch(
                                'snackbar/displaySnackBar',
                                val
                            )
                        }

                        // Reopen button
                        this.isButtonDisabled = false
                    })
            }
        }
    }
}
</script>
